// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AnimatedFormEffect.pas' rev: 4.00

#ifndef AnimatedFormEffectHPP
#define AnimatedFormEffectHPP

#pragma delphiheader begin
#pragma option push -w-
#include <Forms.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Animatedformeffect
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 4)
struct TMathPoint
{
	double X;
	double Y;
} ;
#pragma pack(pop)

#pragma pack(push, 4)
struct TMatrix
{
	double M11;
	double M12;
	double M13;
	double M21;
	double M22;
	double M23;
	double M31;
	double M32;
	double M33;
} ;
#pragma pack(pop)

#pragma pack(push, 4)
struct TSpikeData
{
	TMathPoint TriangleEnd[3][16];
	TMathPoint EndCenter[16];
	TMathPoint TriangleCenter[16];
	TMatrix MatrixCircle[16];
} ;
#pragma pack(pop)

#pragma option push -b-
enum TAnimationType { atInit, atDraw, atErase };
#pragma option pop

#pragma option push -b-
enum TEffectType { etRandom, etSpin, etVortex, etScatterGather, etSpike, etFireworks };
#pragma option pop

class DELPHICLASS TAnimatedFormEffect;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TAnimatedFormEffect : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FAnimateOnShow;
	bool FAnimateOnHide;
	Byte FDelay;
	Byte FFrames;
	Byte FFireworkBlasts;
	TEffectType FEffectType;
	Byte FSteps;
	Classes::TNotifyEvent OldFormShow;
	Classes::TNotifyEvent OldFormHide;
	Forms::TForm* ParentForm;
	HDC DrawDC;
	double EffectParam;
	TMatrix GlobalMatrix;
	TMathPoint FireworksData[256];
	int AfterImages;
	int TotalSteps;
	int Step;
	TMathPoint RightTop;
	TMathPoint Center;
	TSpikeData SpikeData;
	TEffectType CurrentEffect;
	void __fastcall Animate(bool Open);
	void __fastcall AnimationSelect(TAnimationType AnimationType);
	void __fastcall efSpinFrame(TAnimationType AnimationType);
	void __fastcall efVortexFrames(TAnimationType AnimationType);
	void __fastcall efScatterGatherFrames(TAnimationType AnimationType);
	void __fastcall efSpikeFrames(TAnimationType AnimationType);
	void __fastcall efFireworxFrames(TAnimationType AnimationType);
	void __fastcall FormShow(System::TObject* Sender);
	void __fastcall FormHide(System::TObject* Sender);
	
public:
	__fastcall virtual TAnimatedFormEffect(Classes::TComponent* aOwner);
	virtual void __fastcall Loaded(void);
	void __fastcall Open(void);
	void __fastcall Close(void);
	
__published:
	__property bool AnimateOnShow = {read=FAnimateOnShow, write=FAnimateOnShow, nodefault};
	__property bool AnimateOnHide = {read=FAnimateOnHide, write=FAnimateOnHide, nodefault};
	__property Byte Delay = {read=FDelay, write=FDelay, nodefault};
	__property Byte FireworkBlasts = {read=FFireworkBlasts, write=FFireworkBlasts, nodefault};
	__property Byte Frames = {read=FFrames, write=FFrames, nodefault};
	__property TEffectType EffectType = {read=FEffectType, write=FEffectType, nodefault};
	__property Byte Steps = {read=FSteps, write=FSteps, nodefault};
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TAnimatedFormEffect(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Animatedformeffect */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Animatedformeffect;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// AnimatedFormEffect
